=== debian/changelog ===
monado (0.3.0-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for backports.
  * d/rules: Un-comment flag needed before Bullseye

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Fri, 10 Jul 2020 17:53:22 -0500

monado (0.3.0-1) unstable; urgency=medium

  * New upstream version 0.3.0 - substantial upstream changes.
  * Apply cme fixes.
  * d/control:
    - Fix Vcs-Browser, Vcs-Git
    - Add Build-Depends on libx11-xcb-dev
    - Revise package description now that conformance tests are released.
    - Disable optional hidapi dependency on hurd
    - Add Build-Depends: libdbus-1-dev and a Suggests for Bluetooth Low
      Energy support
  * d/copyright: Update
  * d/rules:
    - Disable IPC/service module for now.
    - Fix/use all reproducibility flags.
    - Configure to force system cJSON.
    - Comment out flag only needed before Bullseye.
    - Explicitly disable OpenHMD to avoid confusion/CI issues.
    - Update for upstream config flags
  * d/README.source: Document procedure for updating and backporting package
  * docs: Bundle README.source
  * docs: Ship upstream changelog.
  * Update xml metadata description.

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Fri, 10 Jul 2020 16:53:54 -0500

monado (0.1.0+git269.695ac70d-1~bpo10+1) UNRELEASED; urgency=medium

  * Rebuild for buster-backports.
  * d/rules: Un-comment flag needed before Bullseye

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Mon, 04 May 2020 16:51:07 -0500
